global gWorld, gStates, gObjects, gCurKeyList, void, gCursorlist, sQTCharSprite, sCURSORSPRITE, gHaveNavs, gTempHotRects, gHotRects, cNullSprite

on EnterC10
  if getaProp(getaProp(gStates, #BeenThere), #c10) = 0 then
    Startthetimer(30, "playSound " & QUOTE & "C10vowrk.aif" & QUOTE & ", #file, 1", #EastWestTempObj)
  end if
  if not voidp(getaProp(gObjects, #BBallon)) then
    if getaProp(getaProp(gObjects, #BBallon), #solved) = #true then
      MakeDynamic(#EastWestTempObj, #State, #on)
    else
      MakeDynamic(#EastWestTempObj, #State, #off)
    end if
  else
  end if
  turnOnObj(#EastWestTempObj)
  if getaProp(getaProp(gStates, #BeenThere), #c08) > 0 then
    if (the State of the ThermometerOBJ of gObjects = #off) and (the State of the EastWestTempObj of gObjects = #off) then
      PDARelease("J04m03p.mov")
    end if
  end if
end

on ExitC10
  DelObjects([getaProp(getaProp(gObjects, #eastWestMonitor), #State)])
end

on DragAttr OBJref
  set H to the mouseH
  set V to the mouseV
  set OffsetH to H - getAt(getaProp(getaProp(gObjects, #AttrAnim), #loc), 1)
  set OffsetV to V - getAt(getaProp(getaProp(gObjects, #AttrAnim), #loc), 2)
  set dragThis to getaProp(getaProp(gObjects, OBJref), #dragThis)
  set scoreThis to getaProp(getaProp(gObjects, OBJref), #scoreThis)
  if getaProp(getaProp(gObjects, dragThis), #paused) <> 1 then
    set the pbPauseState of getaProp(getaProp(gObjects, dragThis), #animator) to 1
    set the pbPauseState of getaProp(getaProp(gObjects, scoreThis), #animator) to 1
    if GrabDragCustom(OBJref, dragThis, scoreThis, H, V, OffsetH, OffsetV) then
      MakeDynamic(dragThis, #paused, 1)
    else
      set the loc of sprite getaProp(getaProp(gObjects, #AttrAnim), #SpriteNum) to getaProp(getaProp(gObjects, #AttrAnim), #loc)
      if not voidp(getaProp(getaProp(gObjects, dragThis), #animator)) then
        set the pbPauseState of getaProp(getaProp(gObjects, dragThis), #animator) to 0
        set the pbPauseState of getaProp(getaProp(gObjects, scoreThis), #animator) to 0
      end if
    end if
  end if
  CursorandUpdate()
end

on GrabDragCustom OBJref, dragThis, scoreThis, H, V, OffsetH, OffsetV
  set OBj to getaProp(gObjects, dragThis)
  cursor(getaProp(gCursorlist, #Grab))
  if not voidp(getaProp(getaProp(OBj, #sound), #down)) then
    stopsound(getaProp(getaProp(OBj, #sound), #down))
    playSound(getaProp(getaProp(OBj, #sound), #down), #keyframeCast)
  end if
  set contrainRect to getConstrainRect(dragThis)
  set thisSprite to getaProp(getaProp(gObjects, #AttrAnim), #SpriteNum)
  repeat while the stillDown
    set myLoc to point(the mouseH - OffsetH, the mouseV - OffsetV)
    set the loc of sprite thisSprite to constrainLoc(myLoc, contrainRect)
    CursorandUpdate()
  end repeat
  if not voidp(getaProp(getaProp(OBj, #sound), #UP)) then
    stopsound(getaProp(getaProp(OBj, #sound), #UP))
    playSound(getaProp(getaProp(OBj, #sound), #UP), #keyframeCast)
  end if
  cursor(getaProp(gCursorlist, #Hand))
  CursorandUpdate()
  if checkInsertion(OBJref, dragThis, scoreThis) then
    doInsertAttr()
    return 1
  else
    return 0
  end if
  CursorandUpdate()
end

on constrainLoc myLoc, constrainRect
  if not inside(myLoc, constrainRect) then
    set H to getAt(myLoc, 1)
    set V to getAt(myLoc, 2)
    if H < getAt(constrainRect, 1) then
      set H to getAt(constrainRect, 1)
    end if
    if H > getAt(constrainRect, 3) then
      set H to getAt(constrainRect, 3)
    end if
    if V < getAt(constrainRect, 2) then
      set V to getAt(constrainRect, 2)
    end if
    if V > getAt(constrainRect, 4) then
      set V to getAt(constrainRect, 4)
    end if
    return point(H, V)
  end if
  return myLoc
end

on checkInsertion OBJref, dragThis, scoreThis
  if intersect(the rect of sprite getaProp(getaProp(gObjects, dragThis), #SpriteNum), getAt(getaProp(getaProp(gObjects, OBJref), #insertRect), 1)) > 0 then
    set weatherName to the name of cast the castNum of sprite getaProp(getaProp(gObjects, scoreThis), #SpriteNum)
    set theWeather to getaProp(getaProp(getaProp(gObjects, scoreThis), #stateList), weatherName)
    set wonOnThisTry to score(#weatherObj, theWeather)
    if wonOnThisTry = 1 then
      if the winC of the weatherObj of gObjects = 0 then
        DelObjects([#grabAndDragHotSpot])
        MakeDynamic(#weatherObj, #winC, 1)
        Startthetimer(1, "genExitKF #c02c")
      else
        if the winC of the weatherObj of gObjects = 1 then
          if getaProp(getaProp(gStates, #BeenThere), #d01) then
            MakeDynamic(#weatherObj, #winC, 2)
          end if
        else
        end if
      end if
    end if
    return 1
  else
  end if
  return 0
end

on calcCousinsStateInt OBJref
  if not voidp(gObjects) then
    set myallstates to getaProp(getaProp(gObjects, OBJref), #allStates)
    return getOne(myallstates, getaProp(getaProp(gObjects, OBJref), #currentState))
  else
    return 5
  end if
end

on doInsertAttr
  set myAnimObj to getaProp(gObjects, #AttrAnim)
  set startpoint to the loc of sprite getaProp(myAnimObj, #SpriteNum)
  playSound("C11slot.aif", #keyframeCast)
  set mySeasonsAnim to getaProp(getaProp(gObjects, #SeasonsAnim), #SpriteNum)
  set myAnimSprite to getaProp(getaProp(gObjects, #AttrAnim), #SpriteNum)
  set OrbitObjSpriteNum to getaProp(myAnimObj, #SpriteNum)
  set endPoint to getaProp(myAnimObj, #endPoint)
  drawCurvedline(OrbitObjSpriteNum, startpoint, endPoint, mySeasonsAnim)
  set finalendPoint to getaProp(myAnimObj, #finalendPoint)
  drawLine(OrbitObjSpriteNum, endPoint, finalendPoint)
  DelObjects([#grabAndDragHotSpot])
  set the loc of sprite getaProp(getaProp(gObjects, #SeasonsAnim), #SpriteNum) to point(20000, 20000)
  set the loc of sprite getaProp(getaProp(gObjects, #AttrAnim), #SpriteNum) to point(20000, 20000)
  set the loc of sprite getaProp(getaProp(gObjects, #slotTop), #SpriteNum) to getaProp(getaProp(gObjects, #slotTop), #offloc)
end

on waitfor ticks
  set timeNow to the timer
  set endTime to timeNow + ticks
  repeat while the timer < endTime
  end repeat
end

on donothing
end

on EnterC11
  set aMaxInt to calcCousinsStateInt(#EastWestTempObj)
  set bMaxInt to calcCousinsStateInt(#windspeedObj)
  set cMaxInt to calcCousinsStateInt(#ThermometerOBJ)
  Startthetimer(1, "SetGraphSpriteTrails")
  set AmpList to [0.84999999999999998, 0.69999999999999996, 1.0, 0.5, 0.19999999999999998]
  set Amplitude to getAt(AmpList, bMaxInt)
  setaProp(getaProp(getaProp(gObjects, #WindSpeedGraphObj), #graphList), #Amplitude, Amplitude)
  setaProp(getaProp(getaProp(gObjects, #EastWestBalloonGrafObj), #graphList), #maxRandomInt, aMaxInt)
  setaProp(getaProp(getaProp(gObjects, #WindSpeedGraphObj), #graphList), #maxRandomInt, bMaxInt)
  setaProp(getaProp(getaProp(gObjects, #Rocketc08GraphObj), #graphList), #maxRandomInt, cMaxInt)
  MakeDynamic(#EastWestBalloonGrafObj, #graphList, getaProp(getaProp(gObjects, #EastWestBalloonGrafObj), #graphList))
  MakeDynamic(#WindSpeedGraphObj, #graphList, getaProp(getaProp(gObjects, #WindSpeedGraphObj), #graphList))
  MakeDynamic(#Rocketc08GraphObj, #graphList, getaProp(getaProp(gObjects, #Rocketc08GraphObj), #graphList))
  MakeDynamic(#AttrAnim, #paused, 0)
end

on ExitC11
  cleanUpmySeasonsAnim()
  ResetGraphSpriteTrails()
  DelObjects([#weatherObj, #ControlPanelParent, #windSpeedEnable, #EastWestBalloonEnable, #TempRocketEnable, #Reset, #screensOffLeft, #screensOffRight, #barGraphBkgnd, #C11AccessControlPanel, #AccessYes, #AccessNo, #flashQT, #transAttrQT, #grabAndDragHotSpot, #slotTop])
end

on setGraphSpriteTrails
  set refList to [#WindSpeedGraphObj, #EastWestBalloonGrafObj, #Rocketc08GraphObj]
  repeat with ref in refList
    set the trails of sprite getaProp(getaProp(gObjects, ref), #SpriteNum) to 1
  end repeat
end

on ResetGraphSpriteTrails
  set refList to [#WindSpeedGraphObj, #EastWestBalloonGrafObj, #Rocketc08GraphObj]
  repeat with ref in refList
    set the trails of sprite getaProp(getaProp(gObjects, ref), #SpriteNum) to 0
    set the ink of sprite getaProp(getaProp(gObjects, ref), #SpriteNum) to 36
  end repeat
end

on cleanUpmySeasonsAnim
  set mySeasonsAnim to 17
  set the loc of sprite mySeasonsAnim to point(20000, 20000)
  set the castNum of sprite mySeasonsAnim to cNullSprite
  set the ink of sprite mySeasonsAnim to 36
end

on calcC11grafState
  if voidp(getaProp(gObjects, #ThermometerOBJ)) or voidp(getaProp(gObjects, #windspeedObj)) or voidp(getaProp(gObjects, #EastWestTempObj)) then
    MakeDynamic(#weatherObj, #State, #off)
  else
    if (getaProp(getaProp(gObjects, #WindSpeedGraphObj), #loc) = getaProp(getaProp(gObjects, #WindSpeedGraphObj), #onloc)) and (getaProp(getaProp(gObjects, #EastWestBalloonGrafObj), #loc) = getaProp(getaProp(gObjects, #EastWestBalloonGrafObj), #onloc)) and (getaProp(getaProp(gObjects, #Rocketc08GraphObj), #loc) = getaProp(getaProp(gObjects, #Rocketc08GraphObj), #onloc)) then
      MakeDynamic(#weatherObj, #State, #Access)
    else
      if (getaProp(getaProp(gObjects, #ThermometerOBJ), #State) = #on) or (getaProp(getaProp(gObjects, #windspeedObj), #State) = #on) or (getaProp(getaProp(gObjects, #EastWestTempObj), #State) = #on) then
        MakeDynamic(#weatherObj, #State, #Graphing)
      else
        MakeDynamic(#weatherObj, #State, #off)
      end if
    end if
  end if
  return the State of the weatherObj of gObjects
end

on calcC11AttrState
  if (getaProp(getaProp(gObjects, #ThermometerOBJ), #solved) = 1) and (getaProp(getaProp(gObjects, #windspeedObj), #solved) = 1) and (getaProp(getaProp(gObjects, #EastWestTempObj), #solved) = 1) and (getaProp(getaProp(gObjects, #WindSpeedGraphObj), #loc) = getaProp(getaProp(gObjects, #WindSpeedGraphObj), #onloc)) and (getaProp(getaProp(gObjects, #EastWestBalloonGrafObj), #loc) = getaProp(getaProp(gObjects, #EastWestBalloonGrafObj), #onloc)) and (getaProp(getaProp(gObjects, #Rocketc08GraphObj), #loc) = getaProp(getaProp(gObjects, #Rocketc08GraphObj), #onloc)) then
    return #Attr
  end if
  return the State of the weatherObj of gObjects
end

on playC11lor
  playSound("C11lor.aif", #keyframeCast)
end
